########################################################################
#
# Copyright (c) 1999 by Roger E. Critchlow Jr, Santa Fe, NM, USA,
# rec@elf.org -- http://www.elf.org
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
########################################################################
#
# progress - maintain a progress bar
#
proc progress {op {arg {}}} {
    upvar \#0 .progress data
    if {! [winfo exists .progress]} {
	toplevel .progress
	pack [label .progress.t -textvar .progress(title)]
	image create photo pbar -width 200 -height 20
	pack [label .progress.l -image pbar] -side top -fill x
	set data(percent) -1
    }
    switch $op {
	title {
	    wm deiconify .progress
	    set data(title) $arg
	    update
	}
	percent {
	    set percent [format %6.1f $arg]
	    if {$percent != $data(percent)} {
		pbar blank
		pbar put {{blue}} -to 0 0 [expr int(2*$percent)] 20
		set data(percent) $percent
		update
	    }
	}
	done {
	    pbar blank
	    set data(percent) -1
	    set data(title) {}
	    update
	}
	hide {
	    wm withdraw .progress
	    update
	}
    }
}

