########################################################################
#
# Copyright (c) 1999 by Roger E. Critchlow Jr, Santa Fe, NM, USA,
# rec@elf.org -- http://www.elf.org
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
########################################################################
#
# give a keyword, choose the correct kanji from menu of 12
#
proc keyword-choose-kanji {w op} {
    upvar \#0 $w data
    set f keyword-choose-kanji
    switch $op {
	setup {
	    catch {unset data}
	    wm title $w {Tk Kanji Multiple Choice}

	    set data(select) [tkj-default select]
	    set data(choose) {lindex [tkj-get-field [lindex $data(kanji) $data(i)] ENG] 0}
	    set data(2nd-chance) 1
	    set data(hits) 0
	    set data(tries) 0
	    set data(delay) 2000

	    pack [frame $w.m] -side top -fill x
	    pack [menubutton $w.m.o -text {options} -menu $w.m.o.m] -side left
	    menu $w.m.o.m -tearoff no
	    $w.m.o.m add command -label {Reshuffle list} -command [list $f $w shuffle]
	    $w.m.o.m add command -label {Clear score} -command [list $f $w clear]
	    $w.m.o.m add separator
	    $w.m.o.m add radiobutton -label {Use first meaning} -var ${w}(choose) \
		-value {lindex [tkj-get-field [lindex $data(kanji) $data(i)] ENG] 0}
	    $w.m.o.m add radiobutton -label {Use any meaning} -var ${w}(choose) \
		-value {choose-one [tkj-get-field [lindex $data(kanji) $data(i)] ENG]}
	    $w.m.o.m add separator
	    $w.m.o.m add checkbutton -label {Guess again} -var ${w}(2nd-chance)
	    $w.m.o.m add separator
	    foreach sec {1 2 5} {
		$w.m.o.m add radiobutton -label "Delay $sec sec" -variable ${w}(delay) -value ${sec}000
	    }
	    $w.m.o.m add separator
	    $w.m.o.m add command -label {Done} -command [list tkj-chooser $w]

	    pack [label $w.keyword -border 10] -side top -fill x
	    pack [frame $w.k] -side top -fill x
	    foreach \
		x {0 1 2 3 4 5 6 7 8 9 10 11} \
		i {0 0 0 0 1 1 2 2 3 3  3  3} \
		j {0 1 2 3 0 3 0 3 0 1  2  3} {
		    grid [button $w.b$x -font [tkj-font 24] -command [list $f $w $x]] -in $w.k -row $i -column $j
		}
	    grid [label $w.select -border 10 -font [tkj-font 48]] -in $w.k -row 1 -column 1 -rowspan 2 -columnspan 2
	    pack [label $w.answer -border 10] -side top -fill x
	    pack [label $w.score -textvar ${w}(score)] -side top -fill x

	    pack [tkj-select-menu $w.m.s ${w}(select) [list $f $w start]] -side left

	    $f $w start
	}
	start {
	    set data(kanji) [shuffle [eval $data(select)]]
	    set data(n) [llength $data(kanji)]
	    set data(i) -1
	    $f $w next
	}
	clear {
	    set data(hits) 0
	    set data(tries) 0
	    set data(score) $data(hits)/$data(tries)
	}
	next {
	    incr data(i)
	    while {$data(i) >= $data(n)} {
		set data(kanji) [shuffle $data(kanji)]
		set data(i) [expr {$data(i)-$data(n)}]
	    }
	    $f $w set
	}
	shuffle {
	    set data(kanji) [shuffle $data(kanji)]
	    $f $w set
	}
	set {
	    set data(right) [lindex $data(kanji) $data(i)]
	    $w.keyword configure -text [eval $data(choose)]
	    set data(list) $data(right)
	    while {[llength $data(list)] < 12} {
		set k [lindex $data(kanji) [expr {[random]%$data(n)}]]
		if {[lsearch $data(list) $k] < 0} {
		    lappend data(list) $k
		}
	    }
	    foreach x {0 1 2 3 4 5 6 7 8 9 10 11} k [shuffle $data(list)] {
		$w.b$x configure -text $k
	    }
	    $f $w ready
	}
	ready {
	    $w.select configure -text {}
	    $w.answer configure -text {}
	    set data(score) $data(hits)/$data(tries)
	}
	0 - 1 - 2 - 3 - 4 - 5 - 6 - 7 - 8 - 9 - 10 - 11 {
	    incr data(tries)
	    if {[string compare [$w.b$op cget -text] $data(right)] == 0} {
		$w.select configure -text [$w.b$op cget -text] -fg black
		$w.answer configure -text Correct! -fg black
		incr data(hits)
		after $data(delay) [list $f $w next]
	    } else {
		$w.select configure -text [$w.b$op cget -text] -fg red
		$w.answer configure -text Wrong! -fg red
		if {$data(2nd-chance)} {
		    after $data(delay) [list $f $w ready]
		} else {
		    after $data(delay) [list $f $w next]
		}
	    }
	}
    }
}

proc kanji-multi-choice {w} {
    tkj-empty $w
    keyword-choose-kanji $w setup
}
