########################################################################
#
# Copyright (c) 1999 by Roger E. Critchlow Jr, Santa Fe, NM, USA,
# rec@elf.org -- http://www.elf.org
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
########################################################################
#
# given a keyword, test yourself by writing the kanji
#
proc keyword-show-kanji {w op} {
    upvar \#0 $w data
    set f keyword-show-kanji
    switch $op {
	setup {
	    wm title $w {Tk Kanji Self Test}
	    catch {unset data}
	    set data(select) [tkj-default select]
	    set data(choose) {lindex [tkj-get-field [lindex $data(kanji) $data(i)] ENG] 0}

	    pack [frame $w.m] -side top -fill x
	    pack [menubutton $w.m.o -text {options} -menu $w.m.o.m] -side left
	    menu $w.m.o.m -tearoff no
	    $w.m.o.m add command -label {Clear score} -command [list $f $w clear]
	    $w.m.o.m add command -label {Reshuffle list} -command [list $f $w shuffle]
	    $w.m.o.m add separator
	    $w.m.o.m add radiobutton -label {Use first meaning} -var ${w}(choose) \
		-value {lindex [tkj-get-field [lindex $data(kanji) $data(i)] ENG] 0}
	    $w.m.o.m add radiobutton -label {Use any meaning} -var ${w}(choose) \
		-value {choose-one [tkj-get-field [lindex $data(kanji) $data(i)] ENG]}
	    $w.m.o.m add separator
	    $w.m.o.m add command -label {Done} -command [list tkj-chooser $w]
	    pack [frame $w.g] -side top
	    grid [label $w.keyword -border 10] -in $w.g -row 0 -column 0 -columnspan 12
	    grid [canvas $w.draw -height 70 -width 70 -border 5 -relief ridge] -in $w.g -row 1 -column 0 -columnspan 6
	    grid [label $w.kanji -font [tkj-font 48] -border 5] -in $w.g -row 1 -column 6 -columnspan 6
	    grid [button $w.correct -text Right! -command  [list $f $w correct]] -in $w.g -row 2 -column 0 -columnspan 4
	    grid [button $w.show -text Show -command [list $f $w show]] -in $w.g -row 2 -column 4 -columnspan 4
	    grid [button $w.wrong -text Wrong! -command [list $f $w wrong]] -in $w.g -row 2 -column 8 -columnspan 4
	    grid [label $w.score -textvar ${w}(score)] -in $w.g -row 3 -column 0 -columnspan 12

	    pack [tkj-select-menu $w.m.s ${w}(select) [list $f $w start]] -side left

	    bind $w.draw <ButtonPress-1> {
		set %W(line) [list %W coords [eval %W create line %x %y %x %y -width 2] %x %y]
	    }
	    bind $w.draw <B1-Motion> {
		eval [lappend %W(line) %x %y]
	    }
	    bind $w.draw <ButtonRelease-1> {
		unset %W(line)
	    }
	    $f $w start
	}
	start {
	    set data(kanji) [shuffle [eval $data(select)]]
	    set data(n) [llength $data(kanji)]
	    set data(i) -1
	    set data(hits) 0
	    set data(tries) 0
	    $f $w next
	}
	correct {
	    incr data(hits)
	    incr data(tries)
	    $f $w next
	}
	wrong {
	    incr data(tries)
	    $f $w next
	}
	next {
	    incr data(i)
	    while {$data(i) >= $data(n)} {
		set data(kanji) [shuffle $data(kanji)]
		incr data(i) [expr {-$data(n)}]
	    }
	    $f $w set
	}
	shuffle {
	    set data(kanji) [shuffle $data(kanji)]
	    $f $w set
	}
	set {
	    $w.keyword configure -text [eval $data(choose)]
	    $w.kanji configure -text {}
	    $w.draw delete all
	    set data(score) $data(hits)/$data(tries)
	}
	show {
	    $w.kanji configure -text [lindex $data(kanji) $data(i)]
	}
    }
}

proc kanji-self-test {w} {
    tkj-empty $w
    keyword-show-kanji $w setup   
}